/*
    Creating a dummy version of Cage's Variations II

    Processing sure makes some things easy, but there are certain things that
    completely irk me about it...
*/
import oscP5.*;
//import oscP5.osc.*;
import java.util.Arrays;
import fullscreen.*; 

FullScreen fs; 


// Open Sound Control setup
OscP5 oscP5;
int receiveAtPort, sendToPort;
String host;
String oscP5Event;

PFont lucidaGrande;

// Point setup
int numPoints = 10;
Point[] pointArray;
Point[] originalPointArray;

// Line setup
int numLines = 6;
Line[] lineArray;
//Line l1;
String[] lineNames;

// Button setup
Button startButton;
Button resetButton;

// performance setup
float performanceDuration = 30.0;  // in seconds

float timeWidth = 0.0;   // maximum width for the time line
/* 
not needed anymore:

Point p1 = new Point(10, 10, 8, name);
String name = "1";
*/

void setup() {
    //size(680, 680);
    size(screen.width, screen.height);
    
    background(34);
    smooth();
    ellipseMode(CENTER_RADIUS);
    frameRate(20);
    lucidaGrande = loadFont("LucidaGrande-18.vlw");
    textFont(lucidaGrande, 10);
    textAlign(CENTER);


    startButton = new Button("start", 40, 20, 30, height - 20);
    resetButton = new Button("reset", 40, 20, 90, height - 20);

    setupParameters();
    
    // Create the fullscreen object
  fs = new FullScreen(this); 
  
  // enter fullscreen mode
  fs.enter(); 

}

void setupParameters() {
    pointArray = new Point[numPoints];
    originalPointArray = new Point[numPoints];
    lineArray = new Line[numLines];

    // give our lines some names
    lineNames = new String[numLines];
    lineNames[0] = "Amplitude";
    lineNames[1] = "Frequency";
    lineNames[2] = "Duration";
    lineNames[3] = "Occurence";
    lineNames[4] = "Timbre";
    lineNames[5] = "Time";


    //l1 = new Line(10, height/2, width - 10, height/2, 4, "line");

    for (int i = 0; i < numPoints; i++) {
        pointArray[i] = new Point(10 + i*16, 10 + i*16, 8, Integer.toString(i + 1));
        originalPointArray[i] = new Point(10 + i*16, 10 + i*16, 8, Integer.toString(i + 1));
        //pointArray[i] = new Point(10, 10 + i*10);
    }

    for (int i = 0; i < numLines; i++) {
        /*
        // determine random starting points, scaled appropriately
        float randStartX = width * noise(i);
        float randStartY = height * noise(i*10);

        // random endpoints
        // for now, not constrained by length
        float randEndX = width * noise(i*20);
        float randEndY = height * noise(i*30);
        */

        // determine random starting points, scaled appropriately
        float randStartX = random(width);
        float randStartY = random(height - 60);

        // random endpoints
        // for now, not constrained by length
        float randEndX = random(width);
        float randEndY = random(height - 60);

        while (dist(randStartX, randStartY, randEndX, randEndY) < width/3.0) {
            randEndX = random(width);
            randEndY = random(height);
        }

        lineArray[i] = new Line(randStartX, randStartY,
                                randEndX, randEndY,
                                2, lineNames[i]);
    }

    // initialize OSC communication        
    initOSC();
   
    timeWidth = max(abs(lineArray[5].startX - lineArray[5].endX)/2.0, abs(lineArray[5].startY - lineArray[5].endY)/2.0);

    // setup all of the points
    //pointArray = setupPoints();

}

void draw() {
    background(34);

    // button bar
    strokeWeight(0);
    fill(color(200, 200, 200, 90));
    stroke(color(200, 200, 200, 90));
    rect(width/2, height - (40/2), width, 40);

    textSize(10);
    fill(color(10));
    text("variations 10b <nick knouf>", width - 100, height - (40/2));

    for (int i = 0; i < numLines; i++) {
        lineArray[i].hit();
        lineArray[i].updateDraw();        
    }

    for (int i = 0; i < numPoints; i++) {
        pointArray[i].hit();
        pointArray[i].updateDraw();        
    }

    startButton.update();
    resetButton.update();

    if (resetButton.locked) {
        setupParameters();
        resetButton.locked = false;
    }

    if (startButton.locked) {
        //println("button pressed");
        ArrayList eventList = new ArrayList(numPoints); 

        float[][] eventParameters;
        float[][] eventParametersTest;
        float midX = 0.0, midY = 0.0;
        
        eventParameters = new float[numPoints][numLines];

        // start calculating values for the performance
        for (int i = 0; i < numPoints; i++) {
            pointArray[i].computeParameters();
        }
       
        // taken from:
        // http://forum.java.sun.com/thread.jspa?threadID=716459&messageID=4150630
        Arrays.sort(pointArray, new Comparator() {
            public int compare(Object o1, Object o2) {
                Point a1 = (Point) o1;
                Point a2 = (Point) o2;
                return Float.compare(a1.eventList[5], a2.eventList[5]);
            }
        });

        println("after sorting");
        for (int i = 0; i < numPoints; i++) {
            for (int j = 0; j < numLines; j++) {
                println("Point " + pointArray[i].name + " " + lineArray[j].name + ": " + pointArray[i].eventList[j]);
            }
        }

        println("starting performance...");
        //int counter = 0;
        boolean finished = false;
        // (semi-) time critical stuff begins
        float startTime = millis();
        /* commenting out because we don't do things in real time anymore
        while ((millis() - startTime) < (performanceDuration*1000.0)) {
            if (!finished) {
	            if ((millis() - startTime) > (pointArray[counter].eventList[5] * 1000.0)) {
	                println("sent event " + counter);
	                sendOSCInfo(pointArray[counter].name, pointArray[counter].eventList);
                    
	                counter += 1;
	            }
                
                if (counter == numPoints) {
                    finished = true;
                }
            }
        }
        */
        sendOSCStart();
        for (int counter = 0; counter < pointArray.length; counter++) {
            sendOSCInfo(pointArray[counter].name, pointArray[counter].eventList);
        }
        sendOSCStop();

        startButton.locked = false;
        println("ending performance...");
    }

    //l1.hit();
    //l1.updateDraw();
}

// scale the paramters according to our desires
// in some sense the furthest away we can be is some function of the height
// and width, so we use that here as our max in the scaling function
float scaleParameter(float parameter, int index) {
    if (index == 0) {
        // amplitude, scaleValues to be between 50 and 90
        return scaleValues(parameter, 0, width, 75, 99);
    } else if (index == 1) {
        // frequency, between 100 and 1000
        return scaleValues(parameter, 0, width, 100, 1000);
    } else if (index == 2) {
        // duration, between 0 and 0.1
        return scaleValues(parameter, 0, width, 0.7, 6.8);
    } else if (index == 3) {
        // occurrence, to be determined, scaleValues between 0 and 5
        return scaleValues(parameter, 0, width, 1, 5);
    } else if (index == 4) {
        // timbre, to be determined, scaleValues between 1 and 3
        return scaleValues(parameter, 0, width, 1, 11);
    } else if (index == 5) {
        // time, place in composition, scaleValues between 0 and 1
        return scaleValues(parameter, 0, width, 0, performanceDuration);
    } else {
        return parameter;
    }
}

/*
float scaleValues(float num, float minNum, float maxNum) {
    return ((num - minNum)/(maxNum - minNum));
}
*/

float scaleValues(float num, float minNum, float maxNum, float rangeMin, float rangeMax) {
    // blame this formula on:
    // http://musicalgorithms.ewu.edu/learnmore/norm_dur_scale.html
    return (rangeMin + ((rangeMax - rangeMin) * (num - minNum))/(maxNum - minNum));
    //return ((num - minNum)/(maxNum - minNum));
}
void mousePressed() {
    for (int i = 0; i < numPoints; i++) {
        pointArray[i].updateMousePressed();
    }
    
    startButton.updateMousePressed();
    resetButton.updateMousePressed();
    //l1.updateMousePressed();
}

void mouseReleased() {
    for (int i = 0; i < numPoints; i++) {
        pointArray[i].updateMouseReleased();
        //sendOSCPoint(pointArray[i]);
    }

    startButton.updateMouseReleased();
    resetButton.updateMouseReleased();
}

void mouseDragged() {
    for (int i = 0; i < numPoints; i++) {
        pointArray[i].updateMouseDragged();
    }

    //l1.updateMouseDragged();
}

void initOSC() {
    receiveAtPort = 47110;
    sendToPort = 57140;
    host = "127.0.0.1";
    oscP5Event = "oscEvent";
    oscP5 = new OscP5(this, host, sendToPort, receiveAtPort, oscP5Event);
}

void sendOSCPoint(Point p) {
    OscMessage oscMsg = oscP5.newMsg("/variations2");
    oscMsg.add(p.name);
    oscMsg.add(p.distance);
    oscP5.send(oscMsg);
}

void sendOSCStart() {
    OscMessage oscMsg = oscP5.newMsg("/variations2");
    oscMsg.add("start");
    oscMsg.add(100);
    oscP5.send(oscMsg);
}

void sendOSCStop() {
    OscMessage oscMsg = oscP5.newMsg("/variations2");
    oscMsg.add("perform");
    oscMsg.add(100);
    oscP5.send(oscMsg);
}

void sendOSCInfo(String name, float[] parameters) {
    OscMessage oscMsg = oscP5.newMsg("/variations2");
    
    oscMsg.add(name);

    for (int i = 0; i < parameters.length; i++) {
        // kludge until i figure out how to round data in pd
        if (i == 4) {
            //oscMsg.add(round(parameters[i]));
            oscMsg.add(parameters[i]);
        } else {
            oscMsg.add(parameters[i]);
        }
    }
    oscP5.send(oscMsg);
}
// not really needed, since we're not receiving any events, but we have to have
// it anyway
void oscEvent(OscIn oscIn) {
    unpackMessage(oscIn);
}

void unpackMessage(OscIn oscIn) {
    if (oscIn.checkAddrPattern("/variations2")) {
        int noteNumber = oscIn.getInt(1);
        float stop = oscIn.getFloat(2);

        if ((noteNumber == 0) && (stop > 0)) {
            startButton.inPerformance = true; 
            println("starting performance");
        } else if ((noteNumber == 0) && (stop <= 0)) {
            startButton.inPerformance = false; 
            println("ending performance");
        }

        //println("Received note number " + noteNumber);
        //println(noteNumber + " has a name of " + originalPointArray[noteNumber - 1].name);
        //println("stop value: " + stop);

        if (stop != 0) {
            // println(noteNumber + " drawing inverse");
            for (int i = 0; i < pointArray.length; i++) {
                int noteName = Integer.valueOf(pointArray[i].name).intValue();
                if (noteName == noteNumber) {
                    pointArray[i].drawInverse();
                    pointArray[i].drawTextInfo = true;
                    pointArray[i].updateDraw();
                    break;
                }
            }
        } else {
            // println(noteNumber + " drawing normal");
            for (int i = 0; i < pointArray.length; i++) {
                int noteName = Integer.valueOf(pointArray[i].name).intValue();
                if (noteName == noteNumber) {
                    pointArray[i].drawNormal();
                    pointArray[i].drawTextInfo = false;
                    pointArray[i].updateDraw();
                    break;
                }
            }
        }
    }
}

class Point {
    float xPos;
    float yPos;
    String name = "";
    int radius = 3;
    boolean over = false;
    boolean locked = false;
    float diffX = 0.0; 
    float diffY = 0.0; 
    float distance = 0.0;
    color ellipseFill = color(153);
    color textFill = color(255);

    float[] eventList = new float[numLines];

    float amplitude = 0.0;
    float frequency = 0.0;
    float duration = 0.0;
    float occurrence = 0.0;
    float timbre = 0.0;
    float time = 0.0;

    boolean drawTextInfo = false;

    DecimalFormat df = new DecimalFormat("0.##");

    Point (float x, float y) {
        xPos = x;
        yPos = y;
    }

    Point (float x, float y, int rad) {
        xPos = x;
        yPos = y;
        radius = rad;
    }

    Point (float x, float y, int rad, String n) {
        xPos = x;
        yPos = y;
        radius = rad;
        name = n;
    }


    boolean hit() {
        if ((mouseX > xPos - radius) && (mouseX < xPos + radius) && 
            (mouseY > yPos - radius) && (mouseY < yPos + radius)) {
            over = true; 
            
            stroke(255);
            fill(153);

            return true;
        } else {
            over = false;
            stroke(153);
            fill(153);
            return false;
        }
    }

    void updateMousePressed() {
        //println("mouse pressed");
        if (over) {
            locked = true;
            drawTextInfo = true;
        } else {
            locked = false;
        }
        
        diffX = mouseX - xPos;
        diffY = mouseY - yPos;
    }

    void updateMouseDragged() {
        //println("mouse dragged");
        if (locked) {
            xPos = mouseX - diffX;
            yPos = mouseY - diffY;
        }
    }

    void updateMouseReleased() {
        //println("mouse released");
        //println("Point " + name + " " + "xPos: " + xPos + "; yPos: " + yPos);
        locked = false;
        drawTextInfo = false;
    }

    // draw the inverse color
    void drawInverse() {
        //println("drawing in the inverse color for point" + name);
        ellipseFill = color(255);
        textFill = color(153);
    }

    // draw the normal color
    void drawNormal() {
        //println("drawing in the inverse color for point" + name);
        ellipseFill = color(153);
        textFill = color(255);
    }

    void drawHighlight() {
        // set normal stroke width
        strokeWeight(1);

        fill(157);
        smooth();
        ellipse(xPos, yPos, radius, radius);
        fill(255);
        smooth();
        text(name, xPos, yPos + 4);
    }

    void computeParameters() {
        for (int j = 0; j < numLines; j++) {
            // from http://mathworld.wolfram.com/Point-LineDistance2-Dimensional.html
            eventList[j] = abs(
                (lineArray[j].endX - lineArray[j].startX) *
                (lineArray[j].startY - yPos) -
                (lineArray[j].startX - xPos) *
                (lineArray[j].endY - lineArray[j].startY)) /
                dist(lineArray[j].startX, lineArray[j].startY, lineArray[j].endX, lineArray[j].endY);

                eventList[j] = scaleParameter(eventList[j], j);
            }
    }

    void updateDraw() {
        // set normal stroke width
        strokeWeight(1);

        //distance = sqrt(abs(xPos - width/2.0)^2 + abs(yPos - height/2.0)^2);
        distance = sqrt(pow(abs(xPos - width/2.0), 2) + pow(abs(yPos - height/2.0), 2));
        fill(ellipseFill);
        smooth();
        ellipse(xPos, yPos, radius, radius);
        //fill(255);
        fill(textFill);
        smooth();
        //text(name, xPos, yPos + 4);
        if (drawTextInfo) {
            computeParameters();
            textAlign(LEFT);
            fill(color(255, 85, 43));
            String value = df.format(eventList[0]);
            text("A: " + value + "dB", xPos + 11, yPos - 4);
            value = df.format(eventList[1]);
            text("F: " + value + "Hz", xPos + 11, yPos + 8);
            value = df.format(eventList[2]);
            text("D: " + value + "s", xPos + 11, yPos + 20);
            value = df.format(eventList[5]);
            text("T: " + value + "s", xPos + 11, yPos + 32);
            textAlign(CENTER);
        }
    }
}

class Line {
    float startX;
    float startY;
    float endX;
    float endY;
    String name = "";
    int stroke = 1;
    boolean over = false;
    boolean locked = false;
    float diffX = 0.0; 
    float diffY = 0.0; 
    float distance = 0.0;

    color sColor = color(153);
    color sHoverColor = color(255);
    color bColor = color(153);
    color bHoverColor = color(153);
    color tColor = color(255);
    color tHoverColor = color(153);

    Line(float x1, float y1, float x2, float y2) {
        startX = x1;
        startY = y1;
        endX = x2;
        endY = y2;
    }

    Line(float x1, float y1, float x2, float y2, int s) {
        startX = x1;
        startY = y1;
        endX = x2;
        endY = y2;
        stroke = s;
    }

    Line(float x1, float y1, float x2, float y2, int s, String n) {
        startX = x1;
        startY = y1;
        endX = x2;
        endY = y2;
        stroke = s;
        name = n;
    }


    boolean hit() {
        if ((mouseX > startX) && (mouseX < endX) && 
            (mouseY > startY - (stroke/2)) && (mouseY < endY + (stroke/2))) {
            over = true; 

            //stroke(255);
            //fill(153);

            return true;
        } else {
            over = false;
            //stroke(153);
            //fill(153);
            return false;
        }
    }

    void updateMousePressed() {
        //println("mouse pressed");
        if (over) {
            locked = true;
        } else {
            locked = false;
        }
        
        diffX = mouseX - endX;
        diffY = mouseY - endY;
    }

    void updateMouseDragged() {
        //println("mouse dragged");
        if (locked) {
            startX = mouseX - diffX;
            endX = mouseX - diffX;

            startY = mouseY - diffY;
            endY = mouseY - diffY;
        }
    }

    void updateMouseReleased() {
        //println("mouse released");
        //println("Point " + name + " " + "xPos: " + xPos + "; yPos: " + yPos);
        locked = false;
    }

    void updateDraw() {
        //distance = sqrt(pow(abs(xPos - width/2.0), 2) + pow(abs(yPos - height/2.0), 2));
        stroke(tColor);
        strokeWeight(stroke);
        smooth();
        line(startX, startY, endX, endY);

        // write name of line next to it
        textAlign(CENTER);
        //textMode(SCREEN);
        fill(tColor);
        textSize(10);
        text(name, startX, startY + 9);
    }
}

class Button {
    String name;

    // height and width in pixels
    int bWidth = 40;
    int bHeight = 20;

    int bX = width/2 + bWidth/2;
    int bY = height/2 + bHeight/2;

    boolean over = false, locked = false;

    boolean inPerformance = false;

    color sColor = color(153);
    color sHoverColor = color(255);
    color bColor = color(153);
    color bHoverColor = color(153);
    color tColor = color(255);
    color tHoverColor = color(153);

    Button(String n) {
        setName(n);
    }

    Button(String n, int w, int h) {
        bWidth = w;
        bHeight = h;

        // update default position
        bX = width/2 + bWidth/2;
        bY = height - bHeight/2;
        
        setName(n);
    }

    Button(String n, int w, int h, int x, int y) {
        bWidth = w;
        bHeight = h;

        bX = x;
        bY = y;
        
        setName(n);
    }

    void update() {
        hit();
        updateDraw();
    }

    boolean hit() {
        if ((mouseX > bX - bWidth/2) && (mouseX < bX + bWidth/2) && 
            (mouseY > bY - bHeight/2) && (mouseY < bY + bHeight/2)) {
            over = true; 

            stroke(sHoverColor);
            fill(bHoverColor);

            return true;
        } else {
            over = false;
            stroke(sColor);
            fill(sColor);
            return false;
        }
    }

    void setName(String n) {
        name = n;

        // ensure that the box width is large enough for the name
        if (textWidth(name) > bWidth) {
            bWidth = int(textWidth(name) + 10);
        }

        if ((textAscent() + textDescent()) > bHeight) {
            bHeight = int(textAscent() + textDescent() + 10);
        }
    }

    void updateMousePressed() {
        //println("button mouse pressed");
        if (over) {
            locked = true;
            stroke(sHoverColor);
            fill(bHoverColor);
        } else {
            locked = false;
            stroke(sColor);
            fill(bColor);
        }
    }

    void updateMouseReleased() {
        locked = false;
    }

    void updateDraw() {
        rectMode(CENTER);
        smooth();
        strokeWeight(1);

        if (inPerformance) {
            fill(color(0, 255, 43));
        } else {
            fill(color(255, 85, 43));
        }

        rect(bX, bY, bWidth, bHeight);

        textAlign(CENTER);
        //textMode(SCREEN);
        fill(tColor);
        text(name, bX, bY + 4, bWidth, bHeight);
    }
}
